<template>
  <div>
    <div class="container-fluid topBar">
      <img src="../assets/logo1.png" class="logo" alt="">

        <div class="actions">
            <a href="#">
                <img src="../assets/notification.svg" alt="">
            </a>
            <a href="#">
                <img src="../assets/menu.svg" alt="">
            </a>
        </div>
    </div>
    <div class="container mainContent">
      <navigation></navigation>
      <router-view @updateStudents="updateStudents" @updateSubjects="updateSubjects"></router-view>
    </div>
  </div>
</template>

<script>
import Navigation from './Navigation.vue'
import axios from 'axios'
import {mapGetters} from 'vuex';

export default {
  name: "Dashboard",
  data () {
    return {}
  },

  computed:{
    ...mapGetters([
      'students', 
      'subjects',
      'server'
    ])
  }, 
  
  components: {
    "navigation": Navigation
  }, 

  methods:{
    updateStudents(){ // update the student list with the newest info from database 
      console.log('update students');
      
      var vm = this;
      axios.get(this.server + '/users')
      .then(function (response) {
        // console.log(response);
        vm.$store.commit('setStudents', response.data)
      })
      .catch((error) => {
        console.log(error);
        // vm.errors = []
        // vm.errors.push(error.response.data.error)
      });
    },

    updateSubjects(){ // update the Subject list with the newest info from database 
      var vm = this;
      axios.get(this.server + '/subjects')
      .then(function (response) {
        // console.log(response);
        vm.$store.commit('setSubjects', response.data)
      })
      .catch((error) => {
        console.log(error);
        // vm.errors = []
        // vm.errors.push(error.response.data.error)
      });
    }
  },

  created(){
    this.updateStudents(); 
    this.updateSubjects();
  }
}
</script>

<style>

.topBar {
    width: 100%;
    padding: 15px 30px;
    background: #E71D36;
    color: #fff;
    display: flex;
    justify-content: space-between;
    align-items: center;
    height: 8vh;
}

div.logodiv {
  height: 100%;
  width: fit-content;
}
img.logo {
  float: left;
  height: 140%;
}
div.logo {
  float: left;
    font-size: 30px;
    color: #fff;
    font-weight: 900;
}

.actions {
    float: right;
}

.actions img {
    width: 24px;
    margin-left: 20px;
}

.mainContent {
    height: 92vh;
    display: flex;
}

aside {
    width: 20%;
    box-shadow: 2px 2px 11px 0px rgba(0, 0, 0, 0.23);
    height: 100%;
    position: relative;
}

.userInfo {
    display: flex;
    align-items: center;
    padding: 15px 30px;
}

.userIcon {
    width: 20%;
}

.userIcon img {
    width: 100%;
}

.userText {
    padding: 0px 15px;
}

.userText p {
    font-size: 20px;
}

.userText span {
    font-weight: bold;
    display: block;
}

.menuItems ul{
    list-style: none;
    padding: 0;
    margin: 0;
}

.menuItems li {
    padding: 15px 30px;
    font-size: 18px;
    font-weight: 300;
    box-shadow: 0px 3px 6px rgba(0,0,0,0.16);
    transition: all 0.25s ease-in-out;  
}

.menuItems li:hover {
    background: #E71D36;
    color: #fff;
    cursor: pointer;
}

.menuItems li.active {
    background: #E71D36;
    color: #fff;
}

.content {
    width: 100%;
    padding: 15px 30px;
    display: flex;
}

.studentsList {
    width: 45%;
}

.studentsList h4 {
    font-size: 20px;
    font-weight: 400;
    margin-top: 15px;
    margin-bottom: 15px;
}

.studentsList hr {  
    border: 1px solid rgba(46,196,182,0.45);
}

.studentList {
    display: block;
    width: 100%;
    height: 90%;
    overflow-x: scroll;
    margin-top: 15px;
}

.studentList ul {
    list-style: none;
    margin: 0;
    padding: 0;
}

.studentList li {
    font-size: 18px;
    font-weight: 400;
    margin-bottom: 20px;
    transition: all 0.25s ease-in-out;
}

.studentList li:hover {
    cursor: pointer;
    opacity: 0.8;
    color: #2EC4B6;
}

.newStudent {
    width: 45%;
    margin-left: 5%;
}

.newStudent h4 {
    font-size: 20px;
    font-weight: 400;
    margin-top: 15px;
    margin-bottom: 15px;
}

.newStudent hr {
    border: 1px solid rgba(46,196,182,0.45);
}

.newStudentForm {
    margin-top: 15px;
}

.newStudentForm input {
    width: 48%;
    padding: 9px 15px;
    font-size: 16px;
    color: #000;
    border: 1px solid #2EC4B6;
    margin-bottom: 15px;
}
.newStudentForm input.password {
  width: 100%;
}

.newStudentForm input:nth-child(odd) {
    margin-right: 15px;
}

.newStudentForm input.newStudentSubmit {
    margin-right: 0px;
    background: #2EC4B6;
    width: 100%;
    color: #fff;
    font-size: 22px;
    font-weight: bold;
    text-align: center;
    transition: all 0.25s ease-in-out;
}

.newStudentForm input.newStudentSubmit:hover {
    cursor: pointer;
    opacity: 0.9;
    text-decoration: none;
    transform: translateY(-1px);
}

.newStudentForm input.editUser {
    margin-right: 0px;
    background: #2EC4B6;
    color: #fff;    
    font-weight: bold;
    text-align: center;
    transition: all 0.25s ease-in-out;
}

.newStudentForm input.editUser:hover {
    cursor: pointer;
    opacity: 0.9;
    text-decoration: none;
    transform: translateY(-1px);
}
.logOut {
    position: absolute;
    bottom: 0;
    width: 100%;
}
 .logOut button {
    background: #E71D36;
    color: #fff;
    padding: 15px 30px;
    border: none;
    font-size: 18px;
    font-weight: 300;
    box-shadow: 0px 3px 6px rgba(0,0,0,0.16);
    transition: all 0.25s ease-in-out;  
    width: 100%;
    text-align: left;
    cursor: pointer;
}
 .logout button:hover {
    opacity: 0.9;
} 
</style>